<?php
namespace fox;

/**
 *
 * Class fox\foxException
 *
 * @copyright MX STAR LLC 2018-2022
 * @version 4.0.0
 * @author Pavel Dmitriev
 * @license GPLv3
 *
 **/

class foxException extends \Exception
{

    protected $xCode=null;
    protected $status = "ERR";

    public const STATUS_ERR = "ERR";
    public const STATUS_WARN = "WARN";
    public const STATUS_ALERT = "ALERT";
    public const STATUS_INFO = "INFO";

    public const HTTP_NotAcceptable=406;
    public const HTTP_NotFound=404;
    public const HTTP_InvalidRequest=400;
    public const HTTP_Conflict=409;
    public const HTTP_MethodNotAllowed=405;

    public const HTTPCodeNames = [
        100 => 'Continue',
        101 => 'Switching Protocols',
        102 => 'Processing',
        200 => 'OK',
        201 => 'Created',
        202 => 'Accepted',
        203 => 'Non-Authoritative Information',
        204 => 'No Content',
        205 => 'Reset Content',
        206 => 'Partial Content',
        207 => 'Multi-status',
        208 => 'Already Reported',
        300 => 'Multiple Choices',
        301 => 'Moved Permanently',
        302 => 'Found',
        303 => 'See Other',
        304 => 'Not Modified',
        305 => 'Use Proxy',
        306 => 'Switch Proxy',
        307 => 'Temporary Redirect',
        308 => 'Permanent Redirect',
        400 => 'Bad Request',
        401 => 'Unauthorized',
        402 => 'Payment Required',
        403 => 'Forbidden',
        404 => 'Not Found',
        405 => 'Method Not Allowed',
        406 => 'Not Acceptable',
        407 => 'Proxy Authentication Required',
        408 => 'Request Time-out',
        409 => 'Conflict',
        410 => 'Gone',
        411 => 'Length Required',
        412 => 'Precondition Failed',
        413 => 'Request Entity Too Large',
        414 => 'Request-URI Too Large',
        415 => 'Unsupported Media Type',
        416 => 'Requested range not satisfiable',
        417 => 'Expectation Failed',
        418 => 'I\'m a teapot',
        422 => 'Unprocessable Entity',
        423 => 'Locked',
        424 => 'Failed Dependency',
        425 => 'Unordered Collection',
        426 => 'Upgrade Required',
        428 => 'Precondition Required',
        429 => 'Too Many Requests',
        431 => 'Request Header Fields Too Large',
        451 => 'Unavailable For Legal Reasons',
        500 => 'Internal Server Error',
        501 => 'Not Implemented',
        502 => 'Bad Gateway',
        503 => 'Service Unavailable',
        504 => 'Gateway Time-out',
        505 => 'HTTP Version not supported',
        506 => 'Variant Also Negotiates',
        507 => 'Insufficient Storage',
        508 => 'Loop Detected',
        510 => 'Not Extended',
        511 => 'Network Authentication Required',
    ];
    
    public static function throw($status, $message, $code, $xCode=null, $prev = null)
    {
        $e = new self($message, $code, $prev);
        $e->setStatus($status);
        $e->setXCode($xCode);
        throw $e;
    }

    public function setStatus($status)
    {
        $this->status = $status;
    }
    
    public function setXCode($xCode)
    {
        $this->xCode=$xCode;
    }
    
    public function getStatus()
    {
        return $this->status;
    }

    public function getXCode()
    {
        return empty($this->xCode)?$this->code:$this->xCode;
    }
    
}

?>